#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#define MAX 100
//#define DEBUG 1

void
debug (char *x, ...)
{
#if DEBUG
  va_list va;

  va_start (va, x);
  vfprintf (stderr,x, va);
  fprintf (stderr, "\n");
  va_end (va);
#endif
}

typedef struct _list_
{
  struct _list_ *next;
  struct _list_ *prev;

  char *result;
  int method;

} list;

list *head;
list *tail;

char *method_1 (void);
char *method_2 (void);
int method_3_n (void);
char *method_3 (int);
int method_4_n (void);
char *method_4 (int);
void insert (char *, int);
void delete (void);
int find_rec (char *);
void print_list (void);
void mu (void);

int
main (void)
{
  head = (list *) malloc (sizeof (list));
  head->result = strdup ("mi");
  head->method = 0;

  head->next = head->prev = NULL;
  tail = head;

  mu ();

  return 0;
}

void
insert (char *result, int method)
{
  list *new;

  new = (list *) malloc (sizeof (list));
  new->result = strdup (result);
  new->method = method;

  new->next = NULL;
  new->prev = tail;
  tail->next = new;
  tail = new;
}

void
delete (void)
{
  list *new;

  new = tail;
  if (tail->prev)
    tail->prev->next = NULL;
  tail = tail->prev;

  free (new->result);
  free (new);
}

int
find_rec (char *result)
{
  list *new;

  new = head;
  while (new)
    {
      if (!strcmp (new->result, result))
	return 1;

      new = new->next;
    }

  return 0;
}

char *
method_1 (void)
{
  static char result[MAX];

  if (strlen (tail->result) > MAX - 1)
    {
      debug ("1 - Fuori dalla mia capacita' di calcolo.");
      return NULL;
    }

  sprintf (result, "%su", tail->result);
  debug ("1 - %s", result);

  return result;
}

char *
method_2 (void)
{
  static char result[MAX];

  if ((strlen (tail->result) - 1) > ((MAX / 2) - 1))
    {
      debug ("2 - Fuori dalla mia capacita' di calcolo.");
      return NULL;
    }

  strcpy (result, tail->result);
  strcpy (result + strlen (tail->result), tail->result + 1);
  debug ("2 - %s", result);

  return result;
}

int
method_3_n (void)
{
  register int i, ret = 0;

  if(strlen(tail->result)<3) return 0;

  for (i = 0; i < strlen (tail->result) - 3; i++)
    {
      if (!strncmp (tail->result + i, "iii", 3))
	ret++;
    }

  return ret;
}

char *
method_3 (int ret)
{
  static char result[MAX];
  register int i;

  for (i = 0; i < strlen (tail->result) - 3; i++)
    {
      if (!strncmp (tail->result + i, "iii", 3))
	{
	  if (ret)
	    ret--;
	  else
	    {
	      memcpy (result, tail->result, i);
	      result[i] = 'u';
	      result[i + 1] = 0;
	      strcat (result + i + 1, tail->result + i + 3);

	      debug ("3 - %s", result);
	      return result;
	    }
	}
    }

  return NULL;
}


int
method_4_n (void)
{
  register int i, ret = 0;

  if(strlen(tail->result)<2) return 0;

  for (i = 0; i < strlen (tail->result) - 2; i++)
    {
      if (!strncmp (tail->result + i, "uu", 2))
	ret++;
    }

  return ret;
}

char *
method_4 (int ret)
{
  static char result[MAX];
  register int i;

  for (i = 0; i < strlen (tail->result) - 2; i++)
    {
      if (!strncmp (tail->result + i, "uu", 3))
	{
	  if (ret)
	    ret--;
	  else
	    {
	      memcpy (result, tail->result, i);
	      result[i] = 0;
	      strcat (result, tail->result + i + 2);

	      debug ("4 - %s", result);
	      return result;
	    }
	}
    }

  return NULL;
}

void
print_list (void)
{
  list *new;

  new = head;
  while (new)
    {
      printf ("%d %s\n", new->method, new->result);
      new = new->next;
    }
}

void
mu (void)
{
  char *result;
  register int i;

  if (tail->result[strlen (tail->result) - 1] == 'i')
    {
      if ((result = method_1 ()))
	{
	  if (!strcmp (result, "mu"))
	    {
	      debug ("Trovato!");
	      print_list ();
	    }

	  else if (find_rec (result))
	    debug ("Ricorsione!");

	  else
	    {
	      insert (result, 1);
	      mu ();
	      delete ();
	    }
	}
    }

  if ((result = method_2 ()))
    {

      if (!strcmp (result, "mu"))
	{
	  debug ("Trovato!");
	  print_list ();
	}

      else if (find_rec (result))
	debug ("Ricorsione!");

      else
	{
	  insert (result, 2);
	  mu ();
	  delete ();
	}
    }

  for (i = 0; i < method_3_n (); i++)
    {
      if ((result = method_3 (i)))
	{
	  if (!strcmp (result, "mu"))
	    {
	      debug ("Trovato!");
	      print_list ();
	    }

	  else if (find_rec (result))
	    debug ("Ricorsione!");

	  else
	    {
	      insert (result, 3);
	      mu ();
	      delete ();
	    }
	}
    }

  for (i = 0; i < method_4_n (); i++)
    {
      if ((result = method_4 (i)))
	{
	  if (!strcmp (result, "mu"))
	    {
	      debug ("Trovato!");
	      print_list ();
	    }

	  else if (find_rec (result))
	    debug ("Ricorsione!");

	  else
	    {
	      insert (result, 4);
	      mu ();
	      delete ();
	    }
	}
    }
}
