#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define getrandom(min, max) ((rand() % (int)(((max)) - (min))) + (min))

typedef struct _nodo_ {
  struct _nodo_ *nodi[9];
  char dato[9];
} nodo;

nodo *inizio;

void crea_struttura_rec(nodo *n, int u) {
  register int i;

  for(i=0;i<9;i++) {
    if(!n->dato[i]) {
      n->dato[i]=u;
      
      n->nodi[i]=(nodo *)malloc(sizeof(nodo));
      memset(n->nodi[i], 0, sizeof(nodo));
      memcpy(n->nodi[i]->dato, n->dato, 9);
      crea_struttura_rec(n->nodi[i], u==1 ? 2 : 1);

      n->dato[i]=0;
    }
  }
}

void crea_struttura(int u) {
  inizio = (nodo *)malloc(sizeof(nodo));
  memset(inizio, 0, sizeof(nodo));
  
  crea_struttura_rec(inizio, u);
}

int chi_inizia(void) {
  char ch;

  fprintf(stdout, "Chi inizia? [U/C] ");
  fscanf(stdin, "%c",&ch);

  if(ch=='U' || ch=='u') return 2;
  else return 1;
}

char *
prendi_mossa(char *dato, int u) {
  register int i;

  for(i=0;i<9;i++) {
    switch(dato[i]) {
      case 0: fprintf(stdout, "   %s", !((i+1)%3) ? "\n-----------\n" : "|"); break;
      case 1: fprintf(stdout, " O %s", !((i+1)%3) ? "\n-----------\n" : "|"); break;
      case 2: fprintf(stdout, " X %s", !((i+1)%3) ? "\n-----------\n" : "|"); break;
    }
  }

  i=0;

  while(!i) {
  fprintf(stdout, "Mossa? [1-9] ");
  fscanf(stdin, "%d",&i);

    if(i<10 && i>0) {
      if(dato[i-1]) i=0;
      else dato[i-1]=u;
    } else i=0;
  }

  return dato;
}

nodo *ricerca_dato(char *dato , nodo *n, int u) {
  register int i;

  for(i=0;i<9;i++) {

    if(n->nodi[i] && !(memcmp(n->nodi[i]->dato, dato, 9))) 
      return  n->nodi[i];
  }

  return NULL;
}

int controlla_vinto(char *dato, int u) {
  if(dato[0]==u && dato[1]==u && dato[2]==u) return 1;
  if(dato[3]==u && dato[4]==u && dato[5]==u) return 1;
  if(dato[6]==u && dato[7]==u && dato[8]==u) return 1;
  if(dato[0]==u && dato[3]==u && dato[6]==u) return 1;
  if(dato[1]==u && dato[4]==u && dato[7]==u) return 1;
  if(dato[2]==u && dato[5]==u && dato[8]==u) return 1;
  if(dato[0]==u && dato[4]==u && dato[8]==u) return 1;
  if(dato[2]==u && dato[4]==u && dato[6]==u) return 1;
  return 0;
}

nodo *scegli_mossa(nodo *n, int u) {
  register int i,k;
  nodo *possibili[9];
  nodo *vittorie[9];
  int mosse1=0,mosse2=0, ok=0;

  for(i=0;i<9;i++) {
    possibili[i]=vittorie[i]=NULL;

    if(n->nodi[i]) {
      if(controlla_vinto(n->nodi[i]->dato, 1)==1)
        return n->nodi[i];

      else if(scegli_mossa(n->nodi[i], u)) {
        possibili[mosse1++]=n->nodi[i];
      }
    }
  }

  if(!mosse1) return NULL;

  for(i=0;i<mosse1;i++) {
    ok=0;

    for(k=0;k<9;k++)
      if(possibili[i]->nodi[k])
        if(controlla_vinto(possibili[i]->nodi[k]->dato, 2))
	  ok++;

    if(!ok)
      vittorie[mosse2++]=possibili[i];
  }

  if(mosse2) {
    mosse2=getrandom(0,mosse2);
    return vittorie[mosse2];
  }

  mosse1=getrandom(0,mosse1);
  return possibili[mosse1];
}

int main(void) {
  int u=chi_inizia();
  char dato[9];
  nodo *n;

  srand(getpid());

  crea_struttura(u);
  memset(dato, 0, 9);

  if(u==2) {
    prendi_mossa(dato, u);
    n=ricerca_dato(dato, inizio, u);
    memcpy(dato, n->dato, 9);
  } else
    n=inizio;

  while (1) {
    n=scegli_mossa(n, u);
    if(!n) {puts("Non ho possibilita' di vincere!"); exit(0);}

    memcpy(dato, n->dato, 9);

    switch(controlla_vinto(dato, 1)) {
      case 1: puts("Ho vinto!"); exit(0);
      case 2: puts("Fine partita!"); exit(0);
    }

    prendi_mossa(dato, 2);
    switch(controlla_vinto(dato, 2)) {
      case 1: puts("Hai vinto!"); exit(0);
      case 2: puts("Fine partita!"); exit(0);
    }

    n=ricerca_dato(dato, n, u);
    memcpy(dato, n->dato, 9);
  }

  return 0;
}
